<!DOCTYPE html>

<html lang="en" data-content_root="../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>pipe &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../_static/alabaster.css?v=039e1c02" />
    <script src="../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../_static/doctools.js?v=888ff710"></script>
    <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for pipe</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">time</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>

<span class="kn">import</span> <span class="nn">xml.etree.ElementTree</span> <span class="k">as</span> <span class="nn">ET</span>
<span class="kn">import</span> <span class="nn">json</span>

<span class="kn">from</span> <span class="nn">dotenv</span> <span class="kn">import</span> <span class="n">load_dotenv</span>

<span class="kn">from</span> <span class="nn">helpers</span> <span class="kn">import</span> <span class="n">rules</span><span class="p">,</span> <span class="n">preprocessing</span><span class="p">,</span> <span class="n">helper_functions</span>
<span class="kn">from</span> <span class="nn">scripts</span> <span class="kn">import</span> <span class="n">get_abstracts</span><span class="p">,</span> <span class="n">count_abstracts</span><span class="p">,</span> <span class="n">get_list_of_publishers</span>

<span class="n">filepath_to_doi</span> <span class="o">=</span> <span class="n">helper_functions</span><span class="o">.</span><span class="n">filepath_to_doi</span>
<span class="n">filter_named_entities</span> <span class="o">=</span> <span class="n">helper_functions</span><span class="o">.</span><span class="n">filter_named_entities</span>
<span class="n">crossref_metada_api_call</span> <span class="o">=</span> <span class="n">helper_functions</span><span class="o">.</span><span class="n">crossref_metada_api_call</span>

<span class="n">get_abstracts</span> <span class="o">=</span> <span class="n">get_abstracts</span><span class="o">.</span><span class="n">main</span>
<span class="n">get_list_of_publishers</span> <span class="o">=</span> <span class="n">get_list_of_publishers</span><span class="o">.</span><span class="n">main</span>
<span class="n">count_abstracts</span> <span class="o">=</span> <span class="n">count_abstracts</span><span class="o">.</span><span class="n">main</span>

<div class="viewcode-block" id="cleaning_pipe">
<a class="viewcode-back" href="../pipe.html#pipe.cleaning_pipe">[docs]</a>
<span class="k">def</span> <span class="nf">cleaning_pipe</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Uses function from preprocessing, to clean text.</span>

<span class="sd">    Argumnets:</span>

<span class="sd">        text (str): input string.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: resulting clean text.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">result</span> <span class="o">=</span> <span class="n">text</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">preprocessing</span><span class="o">.</span><span class="n">clean_new_lines</span><span class="p">(</span><span class="n">result</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">preprocessing</span><span class="o">.</span><span class="n">clean_white_spaces</span><span class="p">(</span><span class="n">result</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">preprocessing</span><span class="o">.</span><span class="n">translate_interval_dash</span><span class="p">(</span><span class="n">result</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">preprocessing</span><span class="o">.</span><span class="n">remove_puntuation</span><span class="p">(</span><span class="n">result</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">result</span></div>


<div class="viewcode-block" id="metadata_collector">
<a class="viewcode-back" href="../pipe.html#pipe.metadata_collector">[docs]</a>
<span class="k">def</span> <span class="nf">metadata_collector</span><span class="p">(</span><span class="n">abstracts</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Collects metada from CrossRef.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        abstracts (list): list of abstracts, for which metadata should be collected.</span>
<span class="sd">        vebose (bool): verbose. Defaults to False.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        list: list of metadata, including publication date, title, sourse, authors.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">data_length</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">abstracts</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Collecting metadata...&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">data_length</span><span class="p">):</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">abstracts</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="s1">&#39;doi&#39;</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="si">}</span><span class="s1">/</span><span class="si">{</span><span class="n">data_length</span><span class="o">+</span><span class="mi">1</span><span class="si">}</span><span class="s1">: </span><span class="si">{</span><span class="n">doi</span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">crossref_metada_api_call</span><span class="p">(</span><span class="n">doi</span><span class="p">)</span>
        <span class="n">tmp_res</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;doi&#39;</span><span class="p">:</span> <span class="n">doi</span><span class="p">}</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">==</span> <span class="mi">200</span><span class="p">):</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">json</span><span class="p">()</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;message&#39;</span><span class="p">,</span> <span class="p">{})</span>
            
            <span class="n">publication_date</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;published-print&#39;</span><span class="p">,</span> <span class="p">{})</span>
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;publication_date&#39;</span><span class="p">]</span>  <span class="o">=</span> <span class="n">publication_date</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;date-parts&#39;</span><span class="p">,</span> <span class="p">[])</span>
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;publication_date&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;publication_date&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;publication_date&#39;</span><span class="p">])</span> <span class="k">else</span> <span class="p">[]</span>
            
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;title&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;title&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;source_title&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;container-title&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;source_volume&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;volume&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;source_issue&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;issue&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;source_page&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;page&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
            
            <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;authors&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="n">authors</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;author&#39;</span><span class="p">,</span> <span class="p">[])</span>
            <span class="k">for</span> <span class="n">author</span> <span class="ow">in</span> <span class="n">authors</span><span class="p">:</span>
                <span class="n">author</span> <span class="o">=</span> <span class="n">author</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;given&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39; &#39;</span><span class="o">+</span><span class="n">author</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;family&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
                <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;authors&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">author</span><span class="p">)</span>
        
        <span class="n">result</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tmp_res</span><span class="p">)</span>
    
    <span class="k">return</span> <span class="n">result</span></div>

            



<div class="viewcode-block" id="abstract_collector">
<a class="viewcode-back" href="../pipe.html#pipe.abstract_collector">[docs]</a>
<span class="k">def</span> <span class="nf">abstract_collector</span><span class="p">(</span><span class="n">abstracts_path</span><span class="p">,</span> <span class="n">download</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">download_list</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Gets abstracts from the given path.</span>

<span class="sd">    Arguments:</span>
<span class="sd">    </span>
<span class="sd">        abstracts_path (str): Path from where to look for abstracts.</span>
<span class="sd">        download (bool): Indicates wether to download abstracts or not. Defaults to False.</span>
<span class="sd">        download_list (str): Path to csv file with download list. Defaults to empty string.</span>
<span class="sd">        verbose (bool): verbose. Defaults to False.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        list: Resulting list of cleaned abstracts.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="k">if</span> <span class="n">download</span><span class="p">:</span>
        <span class="n">get_abstracts</span><span class="p">(</span><span class="n">download_list</span><span class="p">,</span> <span class="n">abstracts_path</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>

    <span class="n">data_abstracts</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="n">data_length</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
        <span class="n">relevant_publishers</span> <span class="o">=</span> <span class="n">get_list_of_publishers</span><span class="p">(</span><span class="n">download_list</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">),</span> <span class="s1">&#39;target/&#39;</span><span class="p">),</span> <span class="n">verbose</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Cleaning abstracts...&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">journal_dir</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">abstracts_path</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="n">journal_dir</span><span class="p">)</span>
        <span class="n">cur_dir</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">abstracts_path</span><span class="p">,</span> <span class="n">journal_dir</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">filetype_subdir</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">cur_dir</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="n">filetype_subdir</span><span class="p">)</span>
            <span class="n">cur_dir</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">cur_dir</span><span class="p">,</span> <span class="n">filetype_subdir</span><span class="p">)</span>
            <span class="n">counter</span> <span class="o">=</span> <span class="mi">0</span>
            <span class="n">data_length</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">cur_dir</span><span class="p">))</span>
            <span class="k">for</span> <span class="n">filename</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">cur_dir</span><span class="p">):</span>
                <span class="n">file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">cur_dir</span><span class="p">,</span> <span class="n">filename</span><span class="p">)</span>
                <span class="n">doi</span> <span class="o">=</span> <span class="n">filepath_to_doi</span><span class="p">(</span><span class="n">file_path</span><span class="p">)</span>
                <span class="n">abstract_text</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>

                <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">counter</span><span class="o">+</span><span class="mi">1</span><span class="si">}</span><span class="s1">/</span><span class="si">{</span><span class="n">data_length</span><span class="o">+</span><span class="mi">1</span><span class="si">}</span><span class="s1">: </span><span class="si">{</span><span class="n">doi</span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>

                <span class="k">if</span> <span class="p">(</span><span class="n">filetype_subdir</span> <span class="o">==</span> <span class="s1">&#39;xml&#39;</span><span class="p">):</span>
                    <span class="n">abstract_xml</span> <span class="o">=</span> <span class="n">ET</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">file_path</span><span class="p">)</span>
                    <span class="n">xml_root</span> <span class="o">=</span> <span class="n">abstract_xml</span><span class="o">.</span><span class="n">getroot</span><span class="p">()</span>
                
                    <span class="n">namespace_map</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;dc&#39;</span><span class="p">:</span> <span class="s1">&#39;http://purl.org/dc/elements/1.1/&#39;</span><span class="p">}</span>
                    <span class="n">abstract_text</span> <span class="o">=</span> <span class="n">xml_root</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="s1">&#39;.//dc:description&#39;</span><span class="p">,</span> <span class="n">namespaces</span><span class="o">=</span><span class="n">namespace_map</span><span class="p">)</span>

                    <span class="k">if</span><span class="p">(</span><span class="n">abstract_text</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">abstract_text</span><span class="o">.</span><span class="n">text</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">):</span>
                        <span class="n">abstract_text</span> <span class="o">=</span> <span class="n">abstract_text</span><span class="o">.</span><span class="n">text</span>
                
                <span class="k">elif</span> <span class="p">(</span><span class="n">filetype_subdir</span> <span class="o">==</span> <span class="s1">&#39;json&#39;</span><span class="p">):</span>
                    <span class="n">abstract_json</span> <span class="o">=</span> <span class="kc">None</span>
                    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_path</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">file</span><span class="p">:</span>
                        <span class="n">abstract_json</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">file</span><span class="p">)</span>
                    
                    <span class="k">if</span> <span class="p">(</span><span class="s1">&#39;records&#39;</span> <span class="ow">in</span> <span class="n">abstract_json</span>
                        <span class="ow">and</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">abstract_json</span><span class="p">[</span><span class="s1">&#39;records&#39;</span><span class="p">],</span> <span class="nb">list</span><span class="p">)</span>
                        <span class="ow">and</span> <span class="n">abstract_json</span><span class="p">[</span><span class="s1">&#39;records&#39;</span><span class="p">]</span>
                    <span class="p">):</span>
                        <span class="n">first_record</span> <span class="o">=</span> <span class="n">abstract_json</span><span class="p">[</span><span class="s1">&#39;records&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                        
                        <span class="k">if</span> <span class="s1">&#39;abstract&#39;</span> <span class="ow">in</span> <span class="n">first_record</span><span class="p">:</span>
                            <span class="n">abstract_text</span> <span class="o">=</span> <span class="n">first_record</span><span class="p">[</span><span class="s1">&#39;abstract&#39;</span><span class="p">]</span>
                
                <span class="k">if</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">abstract_text</span><span class="p">)):</span>
                    <span class="n">abstract_text</span> <span class="o">=</span> <span class="n">cleaning_pipe</span><span class="p">(</span><span class="n">abstract_text</span><span class="p">)</span>
                    <span class="n">data_abstracts</span><span class="o">.</span><span class="n">append</span><span class="p">({</span><span class="s1">&#39;doi&#39;</span><span class="p">:</span> <span class="n">doi</span><span class="p">,</span> <span class="s1">&#39;abstract&#39;</span><span class="p">:</span> <span class="n">abstract_text</span><span class="p">})</span>
                    <span class="n">counter</span><span class="o">+=</span><span class="mi">1</span>
    
    <span class="k">return</span> <span class="n">data_abstracts</span></div>


<div class="viewcode-block" id="information_extraction_pipeline">
<a class="viewcode-back" href="../pipe.html#pipe.information_extraction_pipeline">[docs]</a>
<span class="k">def</span> <span class="nf">information_extraction_pipeline</span><span class="p">(</span><span class="n">abstracts</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Extracts nformation from clean abstracts.</span>

<span class="sd">    Argumetns:</span>

<span class="sd">        abstracts (list): list of abstracts.</span>
<span class="sd">        vebose (bool): verbose. Defaults to False.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        list: List of dictionaries with extracted data from rules and NLP.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">data_length</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">abstracts</span><span class="p">)</span>
    
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Extracting information...&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">data_length</span><span class="p">):</span>
        <span class="n">item</span> <span class="o">=</span> <span class="n">abstracts</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
        <span class="n">doi</span> <span class="o">=</span> <span class="n">item</span><span class="p">[</span><span class="s1">&#39;doi&#39;</span><span class="p">]</span>
        <span class="n">abstract</span> <span class="o">=</span> <span class="n">item</span><span class="p">[</span><span class="s1">&#39;abstract&#39;</span><span class="p">]</span>
        <span class="n">tmp_res</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;doi&#39;</span><span class="p">:</span> <span class="n">doi</span><span class="p">}</span>

        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="si">}</span><span class="s1">/</span><span class="si">{</span><span class="n">data_length</span><span class="o">+</span><span class="mi">1</span><span class="si">}</span><span class="s1">: </span><span class="si">{</span><span class="n">doi</span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>
        
        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Rules...&#39;</span><span class="p">)</span>
        
        <span class="n">epoch_numbers</span> <span class="o">=</span> <span class="n">rules</span><span class="o">.</span><span class="n">get_epochs_number</span><span class="p">(</span><span class="n">abstract</span><span class="p">)</span>
        <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;epoch_numbers&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">epoch_numbers</span>

        <span class="n">epoch_names</span> <span class="o">=</span> <span class="n">rules</span><span class="o">.</span><span class="n">get_epoch_name</span><span class="p">(</span><span class="n">abstract</span><span class="p">,</span> <span class="n">epoch_numbers</span><span class="p">)</span>
        <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;epochs&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">epoch_names</span>

        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;NLP...&#39;</span><span class="p">)</span>
        <span class="n">named_entities</span> <span class="o">=</span> <span class="n">rules</span><span class="o">.</span><span class="n">named_entity_bert</span><span class="p">(</span><span class="n">abstract</span><span class="p">)</span>
        <span class="n">locations</span> <span class="o">=</span> <span class="n">filter_named_entities</span><span class="p">(</span><span class="n">named_entities</span><span class="p">,</span> <span class="s1">&#39;LOC&#39;</span><span class="p">)</span>
        
        <span class="n">tmp_res</span><span class="p">[</span><span class="s1">&#39;locations&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">locations</span>

        <span class="n">result</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tmp_res</span><span class="p">)</span>
    
    <span class="k">return</span> <span class="n">result</span></div>


<div class="viewcode-block" id="main">
<a class="viewcode-back" href="../pipe.html#pipe.main">[docs]</a>
<span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">abstracts_path</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">download_abstracts</span><span class="p">,</span> <span class="n">abstract_download_list</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    main function of pipeline. Saves result of the pipeline and returns the result.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        abstracts_path (str): Path from where to read abstracts (if download, where to download abstracts first).</span>
<span class="sd">        output_path (str): Path where to save the result of the pipeline.</span>
<span class="sd">        download_abstracts (bool): Wether to download or no abstracts.</span>
<span class="sd">        abstract_download_list (str): Path to list of abstracts to download (csv with doi column).</span>
<span class="sd">        verbose (bool): verbose. Defaults to False.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        pandas.DataFrame: the result of the pipeline.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">load_dotenv</span><span class="p">()</span>
    <span class="n">time_spent</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;abstract_collections&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
        <span class="s1">&#39;metadata_collection&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
        <span class="s1">&#39;information_extraction&#39;</span><span class="p">:</span> <span class="mi">0</span>
    <span class="p">}</span>
    <span class="n">start_time</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">end_time</span> <span class="o">=</span> <span class="mi">0</span>

    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">start_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="n">abstracts</span> <span class="o">=</span> <span class="n">abstract_collector</span><span class="p">(</span><span class="n">abstracts_path</span><span class="p">,</span> <span class="n">download_abstracts</span><span class="p">,</span> <span class="n">abstract_download_list</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">end_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">time_spent</span><span class="p">[</span><span class="s1">&#39;abstract_collections&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">end_time</span><span class="o">-</span><span class="n">start_time</span>

    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">start_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="n">metadata</span> <span class="o">=</span> <span class="n">metadata_collector</span><span class="p">(</span><span class="n">abstracts</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">end_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">time_spent</span><span class="p">[</span><span class="s1">&#39;metadata_collection&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">end_time</span><span class="o">-</span><span class="n">start_time</span>

    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">start_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="n">extracted</span> <span class="o">=</span> <span class="n">information_extraction_pipeline</span><span class="p">(</span><span class="n">abstracts</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">end_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="n">time_spent</span><span class="p">[</span><span class="s1">&#39;information_extraction&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">end_time</span><span class="o">-</span><span class="n">start_time</span>

    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Abstract collection stage time:</span><span class="se">\t</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">time_spent</span><span class="p">[</span><span class="s1">&#39;abstract_collections&#39;</span><span class="p">])</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Metadata collection stage time:</span><span class="se">\t</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">time_spent</span><span class="p">[</span><span class="s1">&#39;metadata_collection&#39;</span><span class="p">])</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Information extraction stage time:</span><span class="se">\t</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">time_spent</span><span class="p">[</span><span class="s1">&#39;information_extraction&#39;</span><span class="p">])</span>

    <span class="n">metadata</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">metadata</span><span class="p">)</span>
    <span class="n">extracted</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">extracted</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">merge</span><span class="p">(</span><span class="n">metadata</span><span class="p">,</span> <span class="n">extracted</span><span class="p">,</span> <span class="n">on</span><span class="o">=</span><span class="s1">&#39;doi&#39;</span><span class="p">,</span> <span class="n">how</span><span class="o">=</span><span class="s1">&#39;inner&#39;</span><span class="p">)</span>
    <span class="n">result</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">output_path</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">result</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Entrypoint of the pipeline script.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        abstracts_path: Location from where to read abstracts (where to download if download).</span>
<span class="sd">        output_path: Where to save the result.</span>
<span class="sd">        download_abstracts: Optional. --download flag, to first download abstracts.</span>
<span class="sd">        abstract_download_list: Optional. If --download, the list of DOIs.</span>
<span class="sd">        verbose: Optional. -v flag for Verbose.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">download_abstracts</span> <span class="o">=</span> <span class="s1">&#39;--download&#39;</span> <span class="ow">in</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">if</span> <span class="n">download_abstracts</span><span class="p">:</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;--download&#39;</span><span class="p">)</span>
    
    <span class="n">verbose</span> <span class="o">=</span> <span class="s1">&#39;-v&#39;</span> <span class="ow">in</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;-v&#39;</span><span class="p">)</span>

    <span class="n">abstracts_path</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>
    <span class="n">output_path</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>

    <span class="k">if</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">)</span><span class="o">&gt;</span><span class="mi">1</span><span class="p">):</span>
        <span class="n">abstracts_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
        <span class="n">output_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">abstracts_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">),</span> <span class="s1">&#39;target/abstracts/&#39;</span><span class="p">)</span>
        <span class="n">output_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">),</span> <span class="s1">&#39;target/pipe_result.csv&#39;</span><span class="p">)</span>
    
    <span class="n">abstract_download_list</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">),</span> <span class="s1">&#39;source/download_list.csv&#39;</span><span class="p">)</span>
    

    <span class="k">if</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">isdir</span><span class="p">(</span><span class="n">output_path</span><span class="p">)):</span>
        <span class="n">output_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">output_path</span><span class="p">,</span> <span class="s1">&#39;pipe_result.csv&#39;</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">download_abstracts</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">3</span><span class="p">:</span>
        <span class="n">abstract_download_list</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">3</span><span class="p">])</span>
    
    <span class="n">main</span><span class="p">(</span><span class="n">abstracts_path</span><span class="p">,</span> <span class="n">output_path</span><span class="p">,</span> <span class="n">download_abstracts</span><span class="p">,</span> <span class="n">abstract_download_list</span><span class="p">,</span> <span class="n">verbose</span><span class="p">)</span>

    
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
  <li><a href="index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>